#include <bits/stdc++.h>

#define int long long
using namespace std;

vector<vector<int>> z;
vector<int> used;
vector<int> rast;

void DFS(int i) {
    used[i] = 1;
    for (int j = 0; j < z[i].size(); j++) {
        if (used[z[i][j]] == 1) {
            continue;
        }
        rast[z[i][j]] = min(rast[i] + 1, rast[z[i][j]]);
        DFS(z[i][j]);
    }
}

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    z.resize(n);
    rast.resize(n, 1e18);
    used.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        z[x].push_back(y);
        z[y].push_back(x);
    }
    if (t == 0) {
        rast[0] = 0;
        DFS(0);
        std::sort(rast.begin(), rast.end());
        std::reverse(rast.begin(), rast.end());
        for (int i = 0; i < min(k, n); i++) {
            rast[i] = min(rast[i], 1ll);
        }
        std::sort(rast.begin(), rast.end());
        cout << rast.back();
    }  
}

signed main() {
    int e = 1;
    while (e--) {
        solve();
        cout << "\n";
    }
}